// flowWeaver 0.4.3
// neil banas, dec 2010

String vizCredits = "flowWeaver 0.4.3 by Neil Banas";
//String ROOTDIR = "/Users/neil/Documents/Processing/work/flowWeaver/"; // when running inside Processing
String ROOTDIR = ""; // when exporting as an app

/*
new:
  simple toolbar with toggles for the surface and deep flow and a speed slider
*/

/*
to do:
  split this into a trajectory server and a client
  be able to use a series of map background images (to display a tracer)
  gui
    time control
      slider attached to an axes
      plot wind and tides in little axes
    speed control
    rewind, play/pause
    more info
    tools: streaklines, particle patches, particle fountains
  fix pathnames for export as a windows app
  make Axes correctly clip lines to the boundaries (as opposed to points, which already work)
  age fountain
  higher-level methods for AnimatedParticleSet and TrajectorySet, to separate the calculation from the user-interaction stuff?
    this would also make it easy to have multiple animated particle sets
*/

Gui gui;
Display display;
Stylesheet masterStylesheet;
boolean debug = true;
boolean userStartedDoingStuff = false;

void setup() {
  size(873,800);
  smooth();
  if (online) debug = false;
  masterStylesheet = new Stylesheet();
  masterStylesheet.loadFonts();
  display = new Ecohab5Display();
  gui = new Ecohab5Gui();
  gui.display = display;
  display.gui = gui;

}

void draw() {
  display.update();
  gui.update();
  if (display.preloading()) {
    display.preloadNext();
    display.drawPreloadingStatus();
  }
}

void mousePressed() {
  gui.offerMousePress();
}

void mouseDragged() {
  if (!gui.offerMouseDrag()) display.offerMouseDrag();
}

void mouseReleased() {
  if (!gui.offerMouseRelease()) display.offerMouseRelease();
}

void mouseMoved() {
  userStartedDoingStuff = true;
}

